package jello;

public final class Commands {
	
    private static int FindLabel(String label)
    {
        int counter = 0;
        while (counter < InternalState.GetCodeLines().size())
        {
            if (InternalState.GetCodeLine(counter).equals(label))
                return counter;
            counter += 1;
        }
        return 0;
    }
	
    private static int FindNextEnd()
    {
        int counter = InternalState.GetPointer();
        while (counter < InternalState.GetCodeLines().size())
        {
            if (InternalState.GetCodeLine(counter).equals("END"))
                return counter;
            counter += 1;
        }
        return 0;
    }
	
	public static int RunCommand(String command, String[] vals)
    {
		
        //Command: ADD
        if(command.equals("ADD") && vals.length == 1)
        {
        	InternalState.SetRegister((short)(InternalState.GetRegister() + ValueInterpreter.Interpret(vals[0])));
            return 1;
        }

        //Command: SUB
        if(command.equals("SUB") && vals.length == 1)
        {
        	InternalState.SetRegister((short)(InternalState.GetRegister() - ValueInterpreter.Interpret(vals[0])));
            return 1;
        }

        //Command: DIV
        if(command.equals("DIV") && vals.length == 1)
        {
        	InternalState.SetRegister((short)(InternalState.GetRegister() / ValueInterpreter.Interpret(vals[0])));
            return 1;
        }

        //Command: MUL
        if(command.equals("MUL") && vals.length == 1)
        {
        	InternalState.SetRegister((short)(InternalState.GetRegister() * ValueInterpreter.Interpret(vals[0])));
            return 1;
        }

        //Command: SETREG
        if(command.equals("SETREG") && vals.length == 1)
        {
        	InternalState.SetRegister((short)(ValueInterpreter.Interpret(vals[0])));
            return 1;
        }

        //Command: SETMEM
        if(command.equals("SETMEM") && vals.length == 2)
        {
        	InternalState.SetMemory((short)(ValueInterpreter.Interpret(vals[0])), (short)(ValueInterpreter.Interpret(vals[1])));
            return 1;
        }

        //Command: SETOUT
        if(command.equals("SETOUT") && vals.length == 1)
        {
        	InternalState.SetOutput((short)(ValueInterpreter.Interpret(vals[0])));
            System.out.println("  -> OUT: " + InternalState.GetOutput());
            return 1;
        }

        //Command: GETINP
        if(command.equals("GETINP") && vals.length == 0)
        {
            short val = 0;
            System.out.print("  -> INPUT: ");
            try
            {
            	val = Short.parseShort(System.console().readLine());
            }
            catch (NumberFormatException e)
            {
            	InternalState.SetInput((short) 0);
            }
            catch (NullPointerException e)
            {
                System.out.println("Could not find associated console, please run from console.");
                System.exit(1);
            }
            InternalState.SetInput(val);
            return 1;
        }

        //Command: END
        if(command.equals("END") && vals.length == 0)
        {
            return 1;
        }

        //Command: GOTO
        if(command.equals("GOTO") && vals.length == 1)
        {
            if (vals[0].charAt(0) == ':')
            {
                return FindLabel(vals[0]) - InternalState.GetPointer();
            }
            else if (vals[0].charAt(0) == '+' || vals[0].charAt(0) == '-')
            {
                return ValueInterpreter.Interpret(vals[0]);
            }
            else
            {
                return ValueInterpreter.Interpret(vals[0]) - InternalState.GetPointer() - 1;
            }
        }

        //Command: IF with 1 input
        if(command.equals("IF") && vals.length == 1)
        {
            if (vals[0].equals("ZERO"))
            {
                if (InternalState.GetRegister() == 0)
                    return 1;
                else
                    return FindNextEnd() - InternalState.GetPointer();
            }
            return 1;
        }

        //Command: IF with 2 inputs
        if(command.equals("IF") && vals.length == 2)
        {
            if (vals[0].equals("EQ"))
            {
                if (InternalState.GetRegister() == ValueInterpreter.Interpret(vals[1]))
                    return 1;
                else
                    return FindNextEnd() - InternalState.GetPointer();
            }
            else if (vals[0].equals("GT"))
            {
                if (InternalState.GetRegister() > ValueInterpreter.Interpret(vals[1]))
                    return 1;
                else
                    return FindNextEnd() - InternalState.GetPointer();
            }
            else if (vals[0].equals("LT"))
            {
                if (InternalState.GetRegister() < ValueInterpreter.Interpret(vals[1]))
                    return 1;
                else
                    return FindNextEnd() - InternalState.GetPointer();
            }
            else if (vals[0].equals("UN"))
            {
                if (InternalState.GetRegister() != ValueInterpreter.Interpret(vals[1]))
                    return 1;
                else
                    return FindNextEnd() - InternalState.GetPointer();
            }
            return 1;
        }
        
		return 1;
    }
}
