package jello;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map.Entry;

public final class InternalState {
    static private short _Register = 0;
    static private HashMap<Short, Short> _Memory = new HashMap<Short, Short>();
    static private short _Input = 0;
    static private short _Output = 0;
    static private List<String> _CodeLines = new ArrayList<String>();
    static private int _Pointer = 0;
    static private int _LastPointer = 0;

    static public String Dump()
    {
        String dump = "";
        boolean first = true;
        dump += "   @REG = " + _Register + "\n";
        dump += "   @MEM = {";
        for(Iterator<Entry<Short, Short>> i = _Memory.entrySet().iterator(); i.hasNext();)
        {
        	Entry<Short, Short> item = i.next();
            if (!first) dump += ", ";
            else first = false;
            dump += item.getKey() + ":" + item.getValue();
        }
        dump += "}\n";
        dump += "   @INP = " + _Input + "\n";
        dump += "   @OUT = " + _Output;
        return dump;
    }

    static public boolean CleanUp()
    {
        if (_Register > 255 || _Register < 0)
            return true;
        if (_Input > 255 || _Input < 0)
            return true;
        if (_Output > 255 || _Output < 0)
            return true;
        for(Iterator<Entry<Short, Short>> i = _Memory.entrySet().iterator(); i.hasNext();)
        {
        	Entry<Short, Short> item = i.next();
            if (item.getValue() > 255 || item.getValue() < 0 || item.getKey() > 255 || item.getKey() < 0)
                return true;
        }
        return false;
    }

    static public short GetRegister()
    {
        return _Register;
    }
    static public void SetRegister(short value)
    {
        _Register = value;
    }

    static public short GetInput()
    {
        return _Input;
    }
    static public void SetInput(short value)
    {
    	_Input = value;
    }

    static public short GetOutput()
    {
        return _Output;
    }
    static public void SetOutput(short value)
    {
    	_Output = value;
    }

    static public int GetPointer()
    {
        return _Pointer;
    }
    static public void SetPointer(int value)
    {
        _LastPointer = _Pointer;
        _Pointer = value;
    }

    static public int GetLastPointer()
    {
        return _LastPointer;
    }

    static public List<String> GetCodeLines()
    {
        return _CodeLines;
    }
    static public void SetCodeLines(List<String> value)
    {
        _CodeLines = value;
    }
    static public String GetCodeLine(int index)
    {
        return _CodeLines.get(index).trim();
    }

    static public short GetMemory(short index)
    {
    	//System.out.println(index + _Memory.get(index));
        if (_Memory.containsKey(index))
            return _Memory.get(index);
        else
            return 0;
    }

    static public void SetMemory(short index, short value)
    {
        _Memory.put(index, value);
    }

    //TODO: Add stack of 16 items, this will allow for a GOSUB type command and stack manipulation.
}
